<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: admin.inc.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"chart.lib.php", "statistics"
	);

	Extract (
		URLGetArgs("null/null/action=alpha/type=alpha?date=date")
	);

	setDefault("date", "");
	
	switch ($action) {
		case "logs":
		
			header("content-type: text/plain");
			if (!$type || ($type != "referer")) $type = "request";

			$db->query("SELECT counter, url, lastip, lasttime
			FROM ".db_table("stats_uri_logs")."
			WHERE type = '{$type}' ORDER BY counter DESC");

			while ($row = $db->fetch_row()) {
				printf("[%16s, %19s] %5d %s\n", $row["lastip"], date("d/m/Y h:i:s", $row["lasttime"]), $row["counter"], $row["url"]);
			}

			abort();
		break;
		case "detailed":

			if ($date) {
			
				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "statistics/index.admin.tpl");

				$chart = new Chart();

				if (preg_match("/^\d*-\d*-\d*$/", $date)) {
	
					// h00, h01, ..., h23
					$fields = Array();
					for ($i = 0; $i < 24; $i++) {
						$fields[] = "h".str_repeat("0", (2-strlen($i))).$i;
					}
	
					$db->query("SELECT ".implode(", ", $fields).", total, variant
					FROM ".db_table("stats_day")."
					WHERE day = '{$date}' AND (variant='0' OR variant = '1') ORDER BY variant ASC",
					__FILE__, __LINE__);

					$item = Array();
					while ($row = $db->fetch_row()) {
						foreach ($fields as $hour) {
							if (!isset($item[$hour]))
								$item[$hour] = $chart->createItem(substr($hour, 1));

							$chart->addItemNode($item[$hour], $row[$hour], $row["variant"] ? _l("L_TOTAL_HITS") : _l("L_UNIQUE_HITS"));
						}
					}

					$tpl->set("DETAILED.TITLE", strftime("%A %e, %B %Y", date2time($date)));

				} elseif (preg_match("/^\d*-\d*$/", $date)) {
				
					$db->query("SELECT day, total, uniquehits FROM ".db_table("stats_visits")."
					WHERE day >= '$date-1' AND day <= '".date("Y-m-t", date2time($date))."'
					ORDER BY day ASC",
					__FILE__, __LINE__);

					if ($db->num_rows()) {
	
						$buff = Array();
						while ($row = $db->fetch_row()) {
							$item_id = $chart->createItem (
								mkLink (
									"index.php/module=admin/base=statistics/action=detailed?date={$row["day"]}",
									strftime("%A %e", date2time($row["day"]))
								)
							);
							$chart->addItemNode($item_id, $row["uniquehits"], _l("L_UNIQUE_HITS"));
							$chart->addItemNode($item_id, $row["total"], _l("L_TOTAL_HITS"));
						}
						
						$tpl->set("DETAILED.TITLE", strftime("%B %Y", date2time($date)));
					}
					
				} elseif (preg_match("/^\d*$/", $date)) {

					$db->query("SELECT day, total, uniquehits FROM ".db_table("stats_visits")."
					WHERE day >= '$date-1-1' AND day <= '".date("Y-12-t", date2time($date))."'
					ORDER BY day ASC",
					__FILE__, __LINE__);

					if ($db->num_rows()) {
						$buff = Array();
						while ($row = $db->fetch_row()) {
							$id = date("Ym", date2time($row["day"]));
							if (!isset($buff[$id])) {
								$buff[$id] = $row;
							} else {
								$buff[$id]["total"] += $row["total"];
								$buff[$id]["uniquehits"] += $row["uniquehits"];
							}
						}
						foreach ($buff as $row) {
							$item_id = $chart->createItem (
								mkLink (
									"index.php/module=admin/base=statistics/action=detailed?date=".date("Y-m", date2time($row["day"])),
									strftime("%B", date2time($row["day"]))
								)
							);
							$chart->addItemNode($item_id, $row["uniquehits"], _l("L_UNIQUE_HITS"));
							$chart->addItemNode($item_id, $row["total"], _l("L_TOTAL_HITS"));
						}
						
						$tpl->set("DETAILED.TITLE", strftime("%Y", date2time($date)));
					}
				}
				
				$tpl->set_arr (
					Array (
						"BLOCK_TITLE"		=> _l("L_DETAILED_STATISTICS"),
						"BLOCK_ICON"		=> mkIcon("statistics.png", 16),
						"DETAILED.CHART"	=> $chart->make()
					)
				);
	
				$mcBuff = $tpl->make();
			}
		break;
		default:

			$tpl = new ContentBlock();

			$tpl->insert("BLOCK_CONTENT", "statistics/index.admin.tpl");

			$stats = false;
			// user statistics
			$db->query ("
				SELECT
					type, variable, counter
				FROM ".db_table("stats_counter")."
				WHERE type = 'user-agent' OR type = 'user-agent-os'
				",
			__FILE__, __LINE__);
			
			$stats = $db->num_rows();

			$charts = Array();

			while ($row = $db->fetch_row()) {

				// only a chart per type
				if (!isset($charts[$row["type"]]))
					$charts[$row["type"]] = new Chart("350px");

				switch ($row["type"]) {
					case "user-agent":
						$text = isset($stats_user_agent[$row["variable"]]) ? $stats_user_agent[$row["variable"]] : $stats_user_agent[GEKKO_STATS_UNKNOWN_ID];
					break;
					case "user-agent-os":
						$text = isset($stats_os[$row["variable"]]) ? $stats_os[$row["variable"]] : $stats_os[GEKKO_STATS_UNKNOWN_ID];
					break;
					default:
						trigger_error("Unexpected type '{$row["type"]}'", E_USER_ERROR);
					break;
				}
				
				$item_id = $charts[$row["type"]]->createItem($text);
				$charts[$row["type"]]->addItemNode($item_id, $row["counter"]);
			}

			$db->query ("SELECT day, uniquehits, total FROM ".db_table("stats_visits")."
			WHERE day >= '".date("Y-m-0")."' AND day <= '".date("Y-m-t")."' ORDER BY day ASC",
			__FILE__, __LINE__);

			$charts["month"] = new Chart("350px");
			while ($row = $db->fetch_row()) {
				$item_id = $charts["month"]->createItem (
					mkLink (
						"index.php/module=admin/base=statistics/action=detailed?date={$row["day"]}",
						strftime("%A %e", date2time($row["day"]))
					)
				);
				$charts["month"]->addItemNode($item_id, $row["uniquehits"], _l("L_UNIQUE_HITS"));
				$charts["month"]->addItemNode($item_id, $row["total"], _l("L_TOTAL_HITS"));
			}

			// counting total unique visitors and clicks
			$db->query ("SELECT variable, counter FROM ".db_table("stats_counter")."
			WHERE type = 'total' AND
			(variable = 'unique-visits' OR variable = 'clicks')",
			__FILE__, __LINE__);

			$tpl->set_arr (
				Array (
					"TOTAL_VISITORS"	=> 0,
					"TOTAL_CLICKS"		=> 0
				)
			);
			while ($row = $db->fetch_row()) {
				switch ($row["variable"]) {
					case "unique-visits":
						$tpl->set("TOTAL_VISITORS", $row["counter"]);
					break;
					case "clicks":
						$tpl->set("TOTAL_CLICKS", $row["counter"]);
					break;
				}
			}

			$data = Array();

			// actions buttons
			$data["BUTTONS"] = new tplButtonBox();
				$data["BUTTONS"]->add(mklink("index.php/module=admin/base=statistics/action=logs/type=referer", _l("L_REFERER_LOGS")));
				$data["BUTTONS"]->add(mklink("index.php/module=admin/base=statistics/action=logs/type=request", _l("L_URL_REQUEST_LOGS")));
				$data["BUTTONS"]->add(mklink("modules/statistics/main.act.php?action=clear&auth={C_AUTH_STR}", _l("L_CLEAR_LOGS"), false, true));
			$data["BUTTONS"] = $data["BUTTONS"]->make();

			$tpl->set_arr ($data);

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE"		=> _l("L_STATISTICS"),
					"BLOCK_ICON"		=> mkIcon("statistics.png", 16),
					"DETAILED.TITLE"	=> _l("L_MONTH_STATISTICS"),
					"USER_AGENT.CHART"	=> isset($charts["user-agent"]) ? $charts["user-agent"]->make() : "",
					"USER_OS.CHART"		=> isset($charts["user-agent-os"]) ? $charts["user-agent-os"]->make() : "",
					"DETAILED.CHART"	=> isset($charts["month"]) ? $charts["month"]->make() : "",
					"STATS"				=> $stats
				)
			);

			$mcBuff = $tpl->make();

		break;
	}

?>