<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.lib.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	define ("GEKKO_STATS_UNKNOWN_ID", "_unknown");

	// user-agent ids from some browser
	$GLOBALS["stats_user_agent"] = Array (
		"firefox"		=> "Mozilla Firefox",
		"mozilla"		=> "Mozilla",
		"netscape"		=> "Netscape",
		"msie"			=> "Microsoft Internet Explorer",
		"opera"			=> "Opera",
		"konqueror"		=> "Konqueror",
		"lynx"			=> "Lynx",
		"curl"			=> "cURL",
		"w3m"			=> "w3m",
		"wget"			=> "wget",
		"galeon"		=> "Galeon",
		"google"		=> "Google (bot)",
		"msnbot"		=> "MSN (bot)",
		"yahoo"			=> "Yahoo! slurp (bot)",
		GEKKO_STATS_UNKNOWN_ID		=> _l("L_UNKNOWN")
	);

	// user-agent ids for some oses
	$GLOBALS["stats_os"] = Array (
		"win"		=> "Windows",
		"linux"		=> "Linux",
		"mac"		=> "Mac",
		"freebsd"	=> "FreeBSD",
		"netbsd"	=> "NetBSD",
		"sunos"		=> "SunOS",
		"irix"		=> "Irix",
		"beos"		=> "BeOS",
		"os/2"		=> "OS/2",
		GEKKO_STATS_UNKNOWN_ID	=> _l("L_UNKNOWN")
	);

	class Statistics {

		/**
		* increaseCounter(type, variable_name, [increment]);
		* Increments a variable of a determined type
		*/
		function increaseCounter($type, $variable, $increment = 1) {
			$db =& $GLOBALS["db"];
			
			// updating counter if exists
			$q = $db->query("UPDATE ".db_table("stats_counter")."
			SET counter = counter + {$increment}
			WHERE type = '{$type}' AND variable = '{$variable}'",
			__FILE__, __LINE__, true);

			if (!$db->affected_rows($q)) {
				// counter doesn't exists
				$db->query("INSERT INTO ".db_table("stats_counter")." (type, variable, counter)
				VALUES ('{$type}', '{$variable}', {$increment})",
				__FILE__, __LINE__, true);
			}
			return true;
		}
		
		/**
		* checkCounter(type, variable_name);
		* @returns: The current value of specified counter
		*/
		function checkCounter($type, $variable) {
			$db =& $GLOBALS["db"];
			
			$q = $db->query("SELECT counter FROM ".db_table("stats_counter")."
			WHERE type = '{$type}' AND variable = '{$variable}'");

			if ($db->num_rows($q)) {
				$row = $db->fetch_row($q);
				return $row["counter"];
			}

			return 0;
		}
	}

?>